Subject: Re: [PATCH/RFC] Documentation: Say that submodule clones use a separate gitdirs.

From: Junio C Hamano <[email-masked]>
Date: Fri, 07 Mar 2014 15:37:20 -0800

Henri GEIST <[email-masked]> writes:

> This information is technical in nature but has some importance for general users.
> As this kind of clone have a separate gitdir, you will have a surprise if you
> copy past the worktree as the gitdir will not come together.

I am not sure if I understand exactly what you are trying to say.
Are you saying that you had a submodule at "sub/dir" in your working
tree, and then "mkdir ../another && cp -R sub/dir ../another" did
not result in a usable Git working tree in ../another directory?

It is almost like complaining that "mkdir ../newone && cp -R * ../newone/"
did not result in a usable git repository in ../newone directory and
honestly speaking, that sounds borderline insane, I'd have to say.

Yes, if a user knows what she is doing, she should be able to make
something like that work, without running "git clone" (which is
probably the way most users would do it).  And yes, it would be good
to let the user learn from the documentation enough so that she
"knows what she is doing".  But no, I do not think end-user facing
documentation for "git-submodule" subcommand is the way to do that.

That is why I suggested repository-layout as potentially a better
alternative location.

But perhaps I am mis-reading your rationale.